<?php
# Copyright 2004 Todd Palino
#
# This file is part of phpMyRecipes.
#
# phpMyRecipes is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# phpMyRecipes is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# phpMyRecipes; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA

  require("../common-dist.php");
  require('../functions.php');

  function lastIndexOf($haystack, $needle) {
    $pos = strlen($haystack) - (strpos(strrev($haystack), strrev($needle)) + strlen($needle));
    return $pos;
  }

?>
<HTML>
<HEAD>
<TITLE>phpMyRecipes Install - Step 2</TITLE>
</HEAD>

<BODY>
<P><H1><CENTER>phpMyRecipes Installation</CENTER></H1><BR>

<?php
  # Detect the site URL to use
  $port = "";
  switch ($_SERVER['SERVER_PORT']) {
    case 80:
      $site_url = "http://";
      break;
    case 443:
      $site_url = "https://";
      break;
    default:
      $site_url = "http://";
      $port = ":" . $_SERVER['SERVER_PORT'];
      break;
  }
  $site_url .= $_SERVER['HTTP_HOST'] . $port;
  $pos = lastIndexOf($_SERVER['PHP_SELF'], "/install");
  if ($pos === false) {
    print "<P>Your distribution is not correct.  Please start over.</P>\n";
    exit();
  } else {
    $site_url .= substr($_SERVER['PHP_SELF'], 0, $pos) . "/";
  }

?>
<H2>Step 2 - Configuration Parameters</H2></P>

<P>Only a few configuration parameters are needed for phpMyRecipes.  Please
set each one below.  These settings can always be changed later by editing
the common.php file.</P>

<FORM ACTION="step3.php" METHOD=POST>
<TABLE BORDER=0>
  <TR>
    <TD ALIGN=LEFT VALIGN=TOP WIDTH=50%><B>Site Name:</B><BR>
                              The site name is what you want to call your
                              recipes website.  It is used in the title
                              bar of all pages.</TD>
    <TD ALIGN=LEFT VALIGN=TOP WIDTH=50%><INPUT TYPE=text NAME="site_name" VALUE="<?php print SITE_NAME; ?>" SIZE=40 MAXLENGTH=80></TD>
  </TR>
  <TR>
    <TD ALIGN=LEFT VALIGN=TOP WIDTH=50%><B>Base URL:</B><BR>
                              This is the URL to your recipes site.  You
                              probably don't want to change this, as it
                              was detected automatically.  If you do change
                              it, it must end with a "/".</TD>
    <TD ALIGN=LEFT VALIGN=TOP WIDTH=50%><INPUT TYPE=text NAME="site_url" VALUE="<?php print $site_url; ?>" SIZE=40 MAXLENGTH=80></TD>
  </TR>
  <TR>
    <TD ALIGN=LEFT VALIGN=TOP WIDTH=50%><B>Ingredients per page:</B><BR>
                              This is the number of ingredients to display
                              per page on the "Manage Ingredients" page.</TD>
    <TD ALIGN=LEFT VALIGN=TOP WIDTH=50%><INPUT TYPE=text NAME="ing_pp" VALUE="<?php print INGREDIENTS_PER_PAGE; ?>" SIZE=40 MAXLENGTH=80></TD>
  </TR>
  <TR>
    <TD ALIGN=LEFT VALIGN=TOP WIDTH=50%><B>Recipes per page:</B><BR>
                              This is the number of recipes to display per
                              page on the "Browse" pages.</TD>
    <TD ALIGN=LEFT VALIGN=TOP WIDTH=50%><INPUT TYPE=text NAME="recipe_pp" VALUE="<?php print RECIPES_PER_PAGE; ?>" SIZE=40 MAXLENGTH=80></TD>
  </TR>
  <TR>
    <TD ALIGN=LEFT VALIGN=TOP WIDTH=50%><B>Max image size:</B><BR>
                              This is the maximum size, in bytes, that is
                              allowed for uploaded images.</TD>
    <TD ALIGN=LEFT VALIGN=TOP WIDTH=50%><INPUT TYPE=text NAME="max_image" VALUE="<?php print MAX_IMAGE_SIZE; ?>" SIZE=40 MAXLENGTH=80></TD>
  </TR>
  <TR><TD COLSPAN=2>&nbsp;</TD></TR>
</TABLE>
<INPUT TYPE=submit VALUE="Move on to Step 3">
<INPUT TYPE=reset VALUE="Reset Fields">
</FORM>

</BODY>
</HTML>
