<?php
# Copyright 2004 Todd Palino
#
# This file is part of phpMyRecipes.
#
# phpMyRecipes is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# phpMyRecipes is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# phpMyRecipes; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA

  require("../include.php");
  
  if (($dbconn = mysql_pconnect(DB_HOST, DB_USER, DB_PASS)) <= 0) {
    dberror("addrecipe.php", "Cannot connect to database");
  }
  if (! mysql_select_db(DB_DB, $dbconn)) {
    dberror("addrecipe.php", "Cannot select database");
  }

  if (! ($session = getsession()) || !($session{'privs'} & PRIV_ADDRECIPES)) {
    header("Location: " . URL_PREFIX . slink("index.php"));
    exit();
  }

  if (empty($_POST)) {
    # First time through
    paintform("", "", 0, 0, array(), "", "");
    c_footer();
    exit();
  } else {
    # Form submitted, so process it
    $r_name = mysql_real_escape_string($_POST['r_name']);
    $r_category = $_POST['r_category'];
    $r_servings = $_POST['r_servings'];
    $r_ingredients = $_POST['r_ingredients'];
    $r_instructions = mysql_real_escape_string($_POST['r_instructions']);
    $r_description = mysql_real_escape_string($_POST['r_description']);

    if ($r_name == "") {
      paintform("A recipe name is required.", $r_name, $r_category, $r_servings, $r_ingredients, $r_instructions, $r_description);
      c_footer();
      exit();
    }
    if ($result = mysql_query("SELECT id from recipes WHERE name=\"$r_name\"")) {
      if (mysql_num_rows($result) > 0) {
        paintform("That recipe name is already in use.", $r_name, $r_category, $r_servings, $r_ingredients, $r_instructions, $r_description);
        c_footer();
        exit();
      }
    }
    if ($r_category == 0) {
      paintform("You must select a category", $r_name, $r_category, $r_servings, $r_ingredients, $r_instructions, $r_description);
      c_footer();
      exit();
    }
    if ($r_instructions == "") {
      paintform("Instructions for the recipe must be entered", $r_name, $r_category, $r_servings, $r_ingredients, $r_instructions, $r_description);
      c_footer();
      exit();
    }

    # Process the ingredients list
    $ing_list = "";
    if (is_array($r_ingredients)) {
      foreach ($r_ingredients as $ing_line) {
        if ($ing_line != "") {
          list ($qty, $unit, $item_num, $item_text) = split("\*", $ing_line);

          # First check the item num/text
          if ($item_num == 0) {
            $db_id = GetItemIDByName($item_text);
            if ($db_id == 0) {
              dberror("addrecipe.php", "Cannot get ingredient ID by Name");
            }
          } else {
            $db_id = $item_num;
          }

          # Now get/set the Ingredient line ID
          $ing_id = GetIngredientID($qty, $unit, $db_id);
          if ($ing_id == 0) {
            dberror("addrecipe.php", "Cannot insert ingredient line");
          }

          # Add it to the list
          if ($ing_list == "") {
            $ing_list = "$ing_id";
          } else {
            $ing_list .= ",$ing_id";
          }
        }
      }
    }

    # Check the image if we have one
    $ifilename = "";
    if ($_FILES['r_image']['size'] > 0) {
      if (!($ifile_info = getimagesize($_FILES['r_image']['tmp_name'])) || !is_uploaded_file($_FILES['r_image']['tmp_name']) || ($_FILES['r_image']['size'] > MAX_IMAGE_SIZE)) {
        paintform("Image file is not valid", $r_name, $r_category, $r_servings, $r_ingredients, $r_instructions, $r_description);
        c_footer();
        exit();
      }
      $ifilename = sha1_file($_FILE['r_image']['tmp_name']) . "." . $IMAGE_TYPES[$ifile_info[2]];
    }

    # Add the recipe to the database
    if ($result = mysql_query("INSERT INTO recipes (name,servings,ingredients,instructions,description,category,added,creator,imagefile) " .
                              "VALUES(\"$r_name\", $r_servings, \"$ing_list\", \"$r_instructions\", \"$r_description\", $r_category, NOW(), " . $session{'userid'} . ", \"$ifilename\")")) {
      # Move the image file into place, if we need to
      if ($_FILES['r_image']['size'] > 0) move_uploaded_file($_FILES['r_image']['tmp_name'], "../images/recipes/$ifilename");

      paintform("<P CLASS=\"content\"><FONT CLASS=\"content-subheader\">Recipe Added:</FONT><BR>\n$r_name</P>\n",
                "", 0, 0, array(), "", "");
      c_footer();
      exit();
    } else {
      dberror("addrecipe.php", "Cannot insert new recipe");
    }

  }

  function paintform($errtext, $val_name, $val_cat, $val_serv, $val_ing, $val_instr, $val_desc) {
    c_header("Add Recipe", "add");
?>

<SCRIPT LANGUAGE="JavaScript">
<!--
// This is the ingredient formatting widget
function AddIngredient() {
  rform = document.forms.recipe_add_form;
  if ((rform.i_item.value == 0) && (rform.i_item_text.value == "") ||
      rform.i_qty.value == "") {
    alert("You must fill in an ingredient name and a quantity");
    return(false);
  }

  // Create ingredient value field
  ingline = rform.i_qty.value + "*" +
            rform.i_unit.value + "*" +
            rform.i_item.value + "*" +
            rform.i_item_text.value;

  // Create ingredient plain text line
  itemtext = "";
  if (rform.i_item.value == 0) {
    itemtext = rform.i_item_text.value;
  } else {
    option = rform.i_item.selectedIndex;
    itemtext = rform.i_item.options[option].text;
  }
  option = rform.i_unit.selectedIndex;
  unittext = rform.i_unit.options[option].text;
  ingtext = rform.i_qty.value + " " + unittext + " " + itemtext;

  // Add ingredient to selection box
  len = rform.r_ingredients.length;
  rform.r_ingredients.options[len] = new Option(ingtext, ingline);

  // Clear text fields
  rform.i_qty.value = "";
  rform.i_item_text.value  = "";

  // Clear drop downs
  option = rform.i_unit.selectedIndex;
  rform.i_unit.options[0].selected = true;
  rform.i_unit.options[option].selected = false;
  option = rform.i_item.selectedIndex;
  rform.i_item.options[0].selected = true;
  rform.i_item.options[option].selected = false;

  // Change focus
  rform.i_qty.focus();
}

function RemIngredient() {
  rform = document.forms.recipe_add_form;
  len = rform.r_ingredients.length;
  for (i=0; i<len; i++) {
    if (rform.r_ingredients.options[i].selected) {
      rform.r_ingredients.options[i] = null;
      i--;
      len--;
    }
  }
}

function CheckIngredients() {
  rform = document.forms.recipe_add_form;
  len = rform.r_ingredients.length;
  for (i=1; i<len; i++) {
    rform.r_ingredients.options[i].selected = true;
  }
  return true;
}
// -->
</SCRIPT>

<?php
    if ($errtext != "") {
        print "<P CLASS=content><FONT SIZE=+1 COLOR=red>$errtext</FONT></P>\n";
    }
?>

<FORM ENCTYPE="multipart/form-data" ACTION="addrecipe.php" METHOD="POST" NAME="recipe_add_form" onSubmit="if (this.submitted) return CheckIngredients(); else return false;">
<INPUT TYPE="hidden" NAME="MAX_FILE_SIZE" VALUE="<?php print MAX_IMAGE_SIZE; ?>"" />
<?php insSessionField(); ?>

<TABLE WIDTH="100%" BORDER=0>
  <TR>
    <TD ALIGN=LEFT VALIGN=MIDDLE><P CLASS="content"><B>Recipe name:</B></P></TD>
    <TD ALIGN=LEFT VALIGN=MIDDLE><INPUT TYPE=text NAME="r_name" VALUE="<?php print $val_name; ?>" SIZE=40 MAXLENGTH=80></TD>
  </TR>
  <TR>
    <TD ALIGN=LEFT VALIGN=MIDDLE><P CLASS="content"><B>Category:</B></P></TD>
    <TD ALIGN=LEFT VALIGN=MIDDLE><SELECT NAME="r_category">
<OPTION VALUE=0>Select a category</OPTION>
<?php
    print print_subcat_select(1, "|", $val_cat);
?>
                                 </SELECT></TD>
  </TR>
  <TR>
    <TD ALIGN=LEFT VALIGN=MIDDLE><P CLASS="content"><B>Number of Servings:</B></P></TD>
    <TD ALIGN=LEFT VALIGN=MIDDLE><SELECT NAME="r_servings">
                                   <OPTION <?php print ($val_serv == 1) ? "SELECTED" : ""; ?>>1</OPTION>
                                   <OPTION <?php print ($val_serv == 2) ? "SELECTED" : ""; ?>>2</OPTION>
                                   <OPTION <?php print ($val_serv == 3) ? "SELECTED" : ""; ?>>3</OPTION>
                                   <OPTION <?php print ($val_serv == 4) ? "SELECTED" : ""; ?>>4</OPTION>
                                   <OPTION <?php print ($val_serv == 5) ? "SELECTED" : ""; ?>>5</OPTION>
                                   <OPTION <?php print ($val_serv == 6) ? "SELECTED" : ""; ?>>6</OPTION>
                                   <OPTION <?php print ($val_serv == 7) ? "SELECTED" : ""; ?>>7</OPTION>
                                   <OPTION <?php print ($val_serv == 8) ? "SELECTED" : ""; ?>>8</OPTION>
                                   <OPTION <?php print ($val_serv == 9) ? "SELECTED" : ""; ?>>9</OPTION>
                                   <OPTION <?php print ($val_serv == 10) ? "SELECTED" : ""; ?>>10</OPTION>
                                   <OPTION <?php print ($val_serv == 11) ? "SELECTED" : ""; ?>>11</OPTION>
                                   <OPTION <?php print ($val_serv == 12) ? "SELECTED" : ""; ?>>12</OPTION>
                                   <OPTION <?php print ($val_serv == 13) ? "SELECTED" : ""; ?>>13</OPTION>
                                   <OPTION <?php print ($val_serv == 14) ? "SELECTED" : ""; ?>>14</OPTION>
                                   <OPTION <?php print ($val_serv == 15) ? "SELECTED" : ""; ?>>15</OPTION>
                                   <OPTION <?php print ($val_serv == 16) ? "SELECTED" : ""; ?>>16</OPTION>
                                   <OPTION <?php print ($val_serv == 17) ? "SELECTED" : ""; ?>>17</OPTION>
                                   <OPTION <?php print ($val_serv == 18) ? "SELECTED" : ""; ?>>18</OPTION>
                                   <OPTION <?php print ($val_serv == 19) ? "SELECTED" : ""; ?>>19</OPTION>
                                   <OPTION <?php print ($val_serv == 20) ? "SELECTED" : ""; ?>>20</OPTION>
                                   <OPTION <?php print ($val_serv == 21) ? "SELECTED" : ""; ?>>21</OPTION>
                                   <OPTION <?php print ($val_serv == 22) ? "SELECTED" : ""; ?>>22</OPTION>
                                   <OPTION <?php print ($val_serv == 23) ? "SELECTED" : ""; ?>>23</OPTION>
                                   <OPTION <?php print ($val_serv == 24) ? "SELECTED" : ""; ?>>24</OPTION>
                                   <OPTION <?php print ($val_serv == 25) ? "SELECTED" : ""; ?>>25</OPTION>
                                   <OPTION <?php print ($val_serv == 26) ? "SELECTED" : ""; ?>>26</OPTION>
                                   <OPTION <?php print ($val_serv == 27) ? "SELECTED" : ""; ?>>27</OPTION>
                                   <OPTION <?php print ($val_serv == 28) ? "SELECTED" : ""; ?>>28</OPTION>
                                   <OPTION <?php print ($val_serv == 29) ? "SELECTED" : ""; ?>>29</OPTION>
                                   <OPTION <?php print ($val_serv == 30) ? "SELECTED" : ""; ?>>30</OPTION>
                                   <OPTION <?php print ($val_serv == 31) ? "SELECTED" : ""; ?>>31</OPTION>
                                   <OPTION <?php print ($val_serv == 32) ? "SELECTED" : ""; ?>>32</OPTION>
                                   <OPTION <?php print ($val_serv == 33) ? "SELECTED" : ""; ?>>33</OPTION>
                                   <OPTION <?php print ($val_serv == 34) ? "SELECTED" : ""; ?>>34</OPTION>
                                   <OPTION <?php print ($val_serv == 35) ? "SELECTED" : ""; ?>>35</OPTION>
                                   <OPTION <?php print ($val_serv == 36) ? "SELECTED" : ""; ?>>36</OPTION>
                                   <OPTION <?php print ($val_serv == 37) ? "SELECTED" : ""; ?>>37</OPTION>
                                   <OPTION <?php print ($val_serv == 38) ? "SELECTED" : ""; ?>>38</OPTION>
                                   <OPTION <?php print ($val_serv == 39) ? "SELECTED" : ""; ?>>39</OPTION>
                                   <OPTION <?php print ($val_serv == 40) ? "SELECTED" : ""; ?>>40</OPTION>
                                 </SELECT></TD>
  </TR>
  <TR>
    <TD ALIGN=LEFT VALIGN=TOP><P CLASS="content"><B>Description:</B></P></TD>
    <TD ALIGN=LEFT VALIGN=TOP><TEXTAREA NAME="r_description" COLS=60 ROWS=5><?php print $val_desc; ?></TEXTAREA></TD>
  </TR>
  <TR><TD COLSPAN=2><HR></TD></TR>
  <TR>
    <TD ALIGN=LEFT VALIGN=MIDDLE COLSPAN=2><TABLE BORDER=0>
      <TR>
        <TD ALIGN=LEFT VALIGN=MIDDLE COLSPAN=4><P CLASS="content"><B>Ingredients:</B> (Enter each ingredient, then click "Add")</P></TD>
      </TR>
      <TR>
        <TH>Qty</TH>
        <TH>Unit</TH>
        <TH>Item</TH>
        <TH></TH>
      </TR>
      <TR>
        <TD ALIGN=CENTER VALIGN=TOP><INPUT TYPE=text NAME="i_qty" SIZE=5 MAXLENGTH=10></TD>
        <TD ALIGN=CENTER VALIGN=TOP><SELECT NAME="i_unit">
<?php
    if ($result = mysql_query("SELECT id,name from units ORDER BY name")) {
      while ($row = mysql_fetch_array($result)) {
        print "<OPTION VALUE=" . $row{'id'} . ">" . $row{'name'} . "</OPTION>\n";
      }
    } else {
      dberror("addrecipe.php", "Cannot select units");
      exit;
    }
?>
                                    </SELECT></TD>
        <TD ALIGN=LEFT VALIGN=TOP><SELECT NAME="i_item" WIDTH=40>
                                     <OPTION VALUE="0">-------- Select here, or enter below --------</OPTION>
<?php
    if ($result = mysql_query("SELECT id,name from ingredients ORDER BY name")) {
      while ($row = mysql_fetch_array($result)) {
        print "<OPTION VALUE=" . $row{'id'} . ">" . $row{'name'} . "</OPTION>\n";
      }
    } else {
      dberror("addrecipe.php", "Cannot select ingredients");
      exit;
    }
?>
                                   </SELECT><BR>
                                   <INPUT TYPE=text NAME="i_item_text" SIZE=39 MAXLENGTH=80></TD>
        <TD ALIGN=LEFT VALIGN=TOP><INPUT TYPE=button NAME="i_add" VALUE="Add" onClick="javascript:AddIngredient();"></TD>
      </TR>
      <TR>
        <TD ALIGN=LEFT COLSPAN=3><SELECT ID="r_ingredients" NAME="r_ingredients[]" MULTIPLE SIZE=5>
                                   <OPTION VALUE=0>---------------------------------------------------------------------------------------------------</OPTION>
<?php
    if (is_array($val_ing)) {
      # Render existing ingredients list
      foreach ($val_ing as $ing_line) {
        list ($qty, $unit, $item_num, $item_text) = split("\*", $ing_line);

        # Quantity is easy
        print "<OPTION VALUE=\"$ing_line\">$qty ";

        # Get the unit name from the DB
        $unitname = GetUnitNameByID($unit);
        print "$unitname ";

        # Now the item name
        if ($item_num == 0) {
          print "$item_text</OPTION>\n";
        } else {
          $itemname = GetItemNameByID($item_num);
          if ($itemname != "") {
            print "$itemname ";
          } else {
            dberror("addrecipe.php", "Cannot get item name by ID");
          }
        }
      }
    }
?>
                                 </SELECT></TD>
        <TD ALIGN=LEFT VALIGN=TOP><INPUT TYPE=button NAME="i_rem" VALUE="Remove" onClick="javascript:RemIngredient();"></TD>
      </TR>
    </TABLE></TD>
  </TR>
  <TR><TD COLSPAN=2><HR></TD></TR>
  <TR>
    <TD ALIGN=LEFT VALIGN=TOP><P CLASS="content"><B>Instructions:</B></P></TD>
    <TD ALIGN=LEFT VALIGN=TOP><TEXTAREA NAME="r_instructions" COLS=60 ROWS=20><?php print $val_instr; ?></TEXTAREA></TD>
  </TR>
  <TR>
    <TD ALIGN=LEFT VALIGN=MIDDLE><P CLASS="content"><B>Image:</B></P></TD>
    <TD ALIGN=LEFT VALIGN=MIDDLE><INPUT TYPE=file NAME="r_image"></TD>
  </TR>
</TABLE>
<INPUT TYPE=button VALUE="Submit Recipe" onClick="this.form.submitted=true; CheckIngredients(); this.form.submit(); return true;">
<INPUT TYPE=reset VALUE="Reset Form">
</FORM>

<?php
  }
?>
