<?php
# Copyright 2004 Todd Palino
#
# This file is part of phpMyRecipes.
#
# phpMyRecipes is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# phpMyRecipes is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# phpMyRecipes; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA

  require("../include.php");

  if (($dbconn = mysql_pconnect(DB_HOST, DB_USER, DB_PASS)) <= 0) {
    dberror("emailrecipe.php", "Cannot connect to database");
  }
  if (! mysql_select_db(DB_DB, $dbconn)) {
    dberror("emailrecipe.php", "Cannot select database");
  }

  if (empty($_GET) && empty($_POST)) {
    # This can only be called as a form from the search or recipe display page, or by itself
    header("Location: " . URL_PREFIX . slink("index.php"));
    exit();
  }

  if (!($session = getsession()) || !($session{'privs'} & PRIV_EMAILRECIPES)) {
    header("Location: " . URL_PREFIX . slink("index.php"));
    exit();
  }

  if (empty($_POST)) {
    # Get the recipe ID to email
    $r_id = $_GET['r_id'];

    if ($result = mysql_query("SELECT name FROM recipes WHERE id=$r_id")) {
      if (mysql_num_rows($result) == 0) {
        # This code is never reached in normal operation, so get the user out of here
        header("Location: " . URL_PREFIX . slink("index.php"));
        exit();
      }

      $row = mysql_fetch_array($result);

      # Paint the page
      paintform("", getemail_byuserid($session{'userid'}), "", "Recipe - " . $row[0], "Here's a recipe that I thought you might enjoy.", $r_id);
      exit();
    } else {
      dberror("emailrecipe.php", "Cannot retrieve recipe from database");
    }
  } else {
    # Form submitted, so process it
    $r_id = $_POST['r_id'];
    $r_email = $_POST['r_email'];
    $r_subject = $_POST['r_subject'];
    $r_message = $_POST['r_message'];

    if (! validate_email($r_email)) {
      paintform("A valid email address is required.", getemail_byuserid($session{'userid'}), $r_email, $r_subject, $r_message, $r_id);
      exit();
    }

    # Clean up the input
    $r_subject = stripslashes($r_subject);
    $r_message = stripslashes($r_message);

    if (!preg_match("/^[\w\s,.\/<>?;:'\"[\]{}`~!@#$%^&*()+\-=]+$/", $r_subject)) {
      paintform("A valid subject line is required", getemail_byuserid($session{'userid'}), $r_email, $r_subject, $r_message, $r_id);
      exit();
    }
    if (!preg_match("/^[\w\s,.\/<>?;:'\"[\]{}`~!@#$%^&*()+\-=]*$/", $r_message)) {
      paintform("The message must be blank or valid", getemail_byuserid($session{'userid'}), $r_email, $r_subject, $r_message, $r_id);
      exit();
    }

    # Send the email
    $email_message = GetTextRecipe($r_id) . "\n\n---\nSent by phpMyRecipes (http://php-myrecipes.sourceforge.net/) at " . URL_PREFIX . "\n";
    if (!empty($r_message)) $email_message = $r_message . "\n\n---\n\n" . $email_message;
    mail($r_email, $r_subject, $email_message, "From: " . getemail_byuserid($session{'userid'}));
    
    # Redirect back to the recipe view
    header("Location: " . URL_PREFIX . slink("recipes/viewrecipe.php?r_id=$r_id"));
    exit();
  }

  function paintform($errtext, $val_sender, $val_email, $val_subject, $val_message, $val_id) {
    c_header("Email Recipe", "email");
?>

<P CLASS="content">Please enter the email address to send this recipe to.  If you wish, you can
also change the subject line for the email and add a message to be sent at the top of the email.
The email will be sent from the address in your user profile (<?php print $val_sender; ?>).</P>

<?php
    if ($errtext != "") {
        print "<P CLASS=content><FONT SIZE=+1 COLOR=red>$errtext</FONT></P>\n";
    }
?>

<FORM ACTION="emailrecipe.php" METHOD="POST">
<?php insSessionField(); ?>
<INPUT TYPE=hidden NAME="r_id" VALUE="<?php print $val_id; ?>">

<TABLE WIDTH="100%" BORDER=0>
  <TR>
    <TD ALIGN=LEFT VALIGN=MIDDLE><P CLASS="content"><B>Email Address:</B></P></TD>
    <TD ALIGN=LEFT VALIGN=MIDDLE><INPUT TYPE=text NAME="r_email" VALUE="<?php print $val_email; ?>" SIZE=40 MAXLENGTH=80></TD>
  </TR>
  <TR>
    <TD ALIGN=LEFT VALIGN=MIDDLE><P CLASS="content"><B>Subject:</B></P></TD>
    <TD ALIGN=LEFT VALIGN=MIDDLE><INPUT TYPE=text NAME="r_subject" VALUE="<?php print $val_subject; ?>" SIZE=40 MAXLENGTH=80></TD>
  </TR>
  <TR>
    <TD ALIGN=LEFT VALIGN=TOP><P CLASS="content"><B>Message:</B></P></TD>
    <TD ALIGN=LEFT VALIGN=TOP><TEXTAREA NAME="r_message" COLS=60 ROWS=5><?php print $val_message; ?></TEXTAREA></TD>
  </TR>
  <TR><TD COLSPAN=2><HR></TD></TR>
  <TR>
    <TD ALIGN=LEFT VALIGN=MIDDLE COLSPAN=2><P CLASS="content"><B>Recipe Text:</B><BR>
      <BLOCKQUOTE><PRE><?php print GetTextRecipe($val_id); ?></PRE></BLOCKQUOTE></P></TD>
  </TR>
</TABLE>
<INPUT TYPE=submit VALUE="Email Recipe">
<INPUT TYPE=reset VALUE="Reset Form">
</FORM>

<?php
    c_footer();
  }
?>
